//======================================================================================================================================================
// Predator. Based on Asgard's predator fix, normal upak predator 
//needs dll file to work, but I used original rtnp model,
 //model is without import bugs.
//======================================================================================================================================================
class Predator expands ScriptedPawn;

var() byte BiteDamage;	// Basic damage done by bite.

var() float AttackThreshold;
var() float RetreatThreshold;
var() float GroupRadius;

var() bool bDebugLog;

var(Sounds) sound hitsound3;
var(Sounds) sound hitsound4;
var(Sounds) sound Bite;
var(Sounds) sound Footstep;
var(Sounds) sound Footstep2;
var(Sounds) sound Fear2;
var(Sounds) sound Fear3;

var float GroupHealth;
var float AllHealth;
var HomeBase Base;
var float MessageTime;


struct NavPtInfo
{
	var NavigationPoint NavPt;
	var float Distance;
};

function PreBeginPlay()
{
	Super.PreBeginPlay();

	EyeHeight = FMin( CollisionHeight, 48.0 );
	BaseEyeHeight = EyeHeight;
    bHasRangedAttack = false;
	if( CombatStyle == Default.CombatStyle )
	{
		CombatStyle = CombatStyle + 0.3 * FRand() - 0.15;
	}
  MessageTime = 0;   
}

function PlayGutHit(float tweentime)
{
	TweenAnim( 'Death', tweentime );
}

function PlayHeadHit(float tweentime)
{
	TweenAnim( 'Death', tweentime );
}

function PlayLeftHit(float tweentime)
{
	TweenAnim( 'Death', tweentime );
}

function PlayRightHit(float tweentime)
{
	TweenAnim( 'Death', tweentime );
}

function RunStep()
{
	if( FRand() < 0.6 )
		PlaySound( FootStep, SLOT_Interact,0.8,,900 );
	else
		PlaySound( FootStep2, SLOT_Interact,0.8,,900 );
}

function WalkStep()
{
	if( FRand() < 0.6 )
		PlaySound( FootStep, SLOT_Interact,0.2,,500 );
	else
		PlaySound( FootStep2, SLOT_Interact,0.2,,500 );
}

function ZoneChange(ZoneInfo newZone)
{
	bCanSwim = newZone.bWaterZone; //only when it must

	if( newZone.bWaterZone )
		CombatStyle = 1.0; //always charges when in the water
	else if( Physics == PHYS_Swimming )
		CombatStyle = Default.CombatStyle;

	Super.ZoneChange(newZone);
}

/* PreSetMovement()
*/
function PreSetMovement()
{
	bCanJump = true;
	bCanWalk = true;
	bCanSwim = false;
	bCanFly = false;
	MinHitWall = -0.6;
	bCanOpenDoors = false;
	if ( Intelligence > BRAINS_Mammal )
		bCanDoSpecial = true;
	bCanDuck = true;
 if ( Skill <= 3 )
	{
 MaxDesiredSpeed = 0.7 + 0.1 * skill; 
 BiteDamage=default.BiteDamage + (skill *4);
	}
	else
	{
 MaxDesiredSpeed=1.0;
 BiteDamage=default.BiteDamage + 12.0;
	}   
}

function SetMovementPhysics()
{
	if (Physics == PHYS_Falling)
		return;
	if ( Region.Zone.bWaterZone )
		SetPhysics(PHYS_Swimming);
	else
		SetPhysics(PHYS_Walking); 
}

//=========================================================================================
/* AttitudeTo()
Returns the creature's attitude towards another Pawn
*/
function eAttitude AttitudeTo(Pawn Other)
{
	if( Other.bIsPlayer )
	{
		if( bDebugLog ) log( self $ " AttitudeTo(" $ Other $ ") GroupHealth " $ GroupHealth $ " Health " $ Health $ " AttackThreshold " $ AttackThreshold );

  if ( bIsPlayer && Level.Game.IsA('TeamGame') && (Other.PlayerReplicationInfo != none) && (Team == Other.PlayerReplicationInfo.Team) )
  {
   return ATTITUDE_Friendly;
  }
  else if( GroupHealth >= AttackThreshold * Other.Health / 100.0 || AllHealth < AttackThreshold * Other.Health / 100.0 )
		{
			return ATTITUDE_Hate;
		}
		else if( GroupHealth <= RetreatThreshold * Other.Health / 100.0 )
		{
			return ATTITUDE_Fear;
		}
		else if( IsInState( 'Hiding' ) || IsInState( 'Retreating' ) )
		{
			return ATTITUDE_Fear;
		}
		else
		{
			return ATTITUDE_Hate;
		}

	}
    else if ( (TeamTag != '') && (ScriptedPawn(Other) != None) && (TeamTag == ScriptedPawn(Other).TeamTag) )
		return ATTITUDE_Friendly;
	else
		return AttitudeToCreature(Other);
}

function eAttitude AttitudeWithFear()
{
	return ATTITUDE_Fear;
}

function damageAttitudeTo(pawn Other)
{
	local eAttitude OldAttitude;

	if ( (Other == Self) || (Other == None) || (FlockPawn(Other) != None) )
		return;
	if( Other.bIsPlayer ) //change attitude to player
		AttitudeToPlayer = ATTITUDE_Fear;
	else if ( ScriptedPawn(Other) == None )
		Hated = Other;
	SetEnemy(Other);
}

function eAttitude AttitudeToCreature(Pawn Other)
{
	if ( Other.IsA('Predator') )
		return ATTITUDE_Friendly;
	else
		return ATTITUDE_Hate;
}

function PlayWaiting()
{
	local float AnimSpeed;
	AnimSpeed = 0.3 + 0.6 * FRand(); //vary speed
	if( FRand() < 0.05 )
	{
		SetAlertness( 0.5 );
		PlayAnim( 'look', AnimSpeed, 0.2 );
	}
	else
	{
		SetAlertness( 0.0 );
		PlayAnim( 'idle', AnimSpeed, 0.2 );
	}
}

function PlayWaitingAmbush()
{
	PlayWaiting();
}

function PlayDive()
{
	TweenToSwimming( 0.2 );
}

function TweenToWaiting(float tweentime)
{
	if (Region.Zone.bWaterZone)
	{
		TweenToSwimming(tweentime);
		return;
	}
  TweenAnim('idle', tweentime);
}

function TweenToFighter(float tweentime)
{
	if (Region.Zone.bWaterZone)
	{
		TweenToSwimming(tweentime);
		return;
	}
	else
	{
		TweenAnim('Run', tweentime);
	}
}

function TweenToRunning(float tweentime)
{
	if (Region.Zone.bWaterZone)
	{
		TweenToSwimming(tweentime);
		return;
	}
	else if ( ((AnimSequence != 'Run') && (AnimSequence != 'RunBite')) || !bAnimLoop )
	TweenAnim('Run', tweentime);
}

function TweenToWalking(float tweentime)
{
	if (Region.Zone.bWaterZone)
	{
		TweenToSwimming(tweentime);
		return;
	}
	TweenAnim('Walk', tweentime);
}

function TweenToPatrolStop(float tweentime)
{
	if (Region.Zone.bWaterZone)
	{
		TweenToSwimming(tweentime);
		return;
	}
  TweenAnim('idle', tweentime);
}

function PlayWalking()
{
	if (Region.Zone.bWaterZone)
	{
		PlaySwimming();
		return;
	}
	LoopAnim('Walk', 0.88);
}

function TweenToSwimming(float tweentime)
{
	if ( !bAnimLoop )
		TweenAnim('Walk', tweentime);
}

function PlaySwimming()
{
	LoopAnim('Walk', -1.0/WaterSpeed,, 0.5);
}

function PlayTurning()
{
	if (Region.Zone.bWaterZone)
	{
		PlaySwimming();
		return;
	}
	else
		TweenAnim('Walk', 0.3);
}

function PlayBigDeath(name DamageType)
{
	PlayAnim( 'Death', 0.7, 0.1 );
	PlaySound( Die, SLOT_Talk, 4.5 * TransientSoundVolume );
}

function PlayHeadDeath(name DamageType)
{
	local carcass carc;

	if ( (DamageType == 'Decapitated') || ((Health < -20) && (FRand() < 0.5)) )
	{
		carc = Spawn(class 'CreatureChunks',,, Location + CollisionHeight * vect(0,0,0.8), Rotation + rot(3000,0,16384) );
		if (carc != None)
		{
			carc.Mesh = mesh'PredatorHead';
			carc.Initfor(self);
			carc.Velocity = Velocity + VSize(Velocity) * VRand();
			carc.Velocity.Z = FMax(carc.Velocity.Z, Velocity.Z);
		}
		PlayAnim( 'Death', 0.7, 0.1 );
		if ( IsA('Predator') && (Velocity.Z < 120) )
		{
			Velocity = GroundSpeed * vector(Rotation);
			Velocity.Z = 150;
		}
	}
	else
		PlayAnim( 'Death', 0.7, 0.1 );
	PlaySound( Die, SLOT_Talk, 4.5 * TransientSoundVolume );
}

function PlayLeftDeath(name DamageType)
{
	PlayAnim( 'Death', 0.7, 0.1 );
	PlaySound( Die, SLOT_Talk, 4.5 * TransientSoundVolume );
}

function PlayRightDeath(name DamageType)
{
	PlayAnim( 'Death', 0.7, 0.1 );
	PlaySound( Die, SLOT_Talk, 4.5 * TransientSoundVolume );
}

function PlayGutDeath(name DamageType)
{
	PlayAnim('Death',0.7, 0.1);
	PlaySound(Die, SLOT_Talk, 4.5 * TransientSoundVolume);
}

function PlayTakeHitSound(int Damage, name damageType, int Mult)
{
	local float decision;

	if ( Level.TimeSeconds - LastPainSound < 0.25 )
		return;
	LastPainSound = Level.TimeSeconds;

	decision = FRand(); //FIXME - modify based on damage
	if (decision < 0.25)
		PlaySound(HitSound1, SLOT_Pain, 2.0 * Mult);
	else if (decision < 0.5)
		PlaySound(HitSound2, SLOT_Pain, 2.0 * Mult);
	else if (decision < 0.75)
		PlaySound(HitSound3, SLOT_Pain, 2.0 * Mult);
	else
		PlaySound(HitSound4, SLOT_Pain, 2.0 * Mult);
}

function PlayFearSound()
{
	local float decision;

	decision = FRand();
	if( Fear != None && decision < 0.33 )
		PlaySound( Fear, SLOT_Talk,, true );
	else if( Fear2 != None && decision < 0.67 )
		PlaySound( Fear2, SLOT_Talk,, true );
	else if( Fear3 != None )
		PlaySound( Fear3, SLOT_Talk,, true );
	else if( Fear2 != None )
		PlaySound( Fear2, SLOT_Talk,, true );
	else if( Fear != None )
		PlaySound( Fear, SLOT_Talk,, true );
}

function TweenToFalling()
{
	if ( FRand() < 0.5 )
		TweenAnim('Run', 0.2);
	else
		PlayAnim('Jump',0.7,0.1);
}

function PlayInAir()
{
	if( AnimSequence == 'Run' )
		PlayAnim( 'Run', 0.4 );
	else if( AnimSequence == 'RunBite' )
		PlayAnim( 'RunBite', 0.4 );
	else
		TweenAnim( 'Idle', 0.4 );
}

function PlayLanded(float impactVel)
{
  TweenAnim('landed',0.2);
}

function PlayTakeHit(float tweentime, vector HitLoc, int damage)
{
	if ( (Velocity.Z > 120) && (Health < 0.4 * Default.Health) && (FRand() < 0.33) )
		PlayAnim( 'Wound', 0.7 );

		Super.PlayTakeHit( tweentime, HitLoc, damage );
}

function BiteDamageTarget()
{
	if ( Target == None )
		return;
 if( MeleeDamageTarget( BiteDamage, ( BiteDamage * 1000 * Normal( Target.Location - Location ) ) ) )
		PlaySound(Bite, SLOT_Interact);
}

function PlayMeleeAttack()
{
	local float diff, tinyjump;

 if (Target == None)
		return;
 if (Region.Zone.bWaterZone)
 {
  PlayAnim('bite');
		return;
	}
	if (Physics==PHYS_Walking)  
 {
  if(Target.Location.z - Target.CollisionHeight > Location.Z - CollisionHeight/2)
		{
	 diff= Target.Location.z - Location.Z;
  tinyjump=diff+(Target.CollisionHeight*2.5);
 	if ( tinyjump > jumpz )
   tinyjump=jumpz;
 	if (tinyjump >50 )
   {
    velocity.Z = tinyjump; 
		  setphysics(PHYS_Falling);
    PlayAnim('Jumpbite');
   }
			else
    PlayAnim('bite');
		return;
  }
 }
	PlayAnim('bite'); 
}

function bool xxMovingMelee()   // bump stop
{
 local float speed;
 
 speed = VSize(Velocity);
	if ( speed > 50 )
  return true;
	else
  Acceleration = vect(0,0,0); 
  return false;
}

function PlayMovingMelee()
{
		PlayAnim('runbite');
}

function float GetGroupHealth()
{
	local Predator Peer;

	GroupHealth = Health;
	foreach VisibleActors( class'Predator', Peer, GroupRadius )
	{
		if( Peer != Self )
		{
			GroupHealth += Peer.Health;
		}
	}
	return GroupHealth;
}

function float GetAllHealth()
{
	local Predator aPredator;

	AllHealth = Health;
	foreach RadiusActors( class'Predator', aPredator, GroupRadius * 4.0 )
	{
		if( aPredator != Self )
		{
			AllHealth += aPredator.Health;
		}
	}
	return AllHealth;
}

function NotifyPeers( name Message, Pawn Other )
{
	local Predator Friend;

	
 if ( Level.TimeSeconds - MessageTime < 0.2 )
	return;
 else
	MessageTime = Level.TimeSeconds;
 if( bDebugLog ) Log( self $ " NotifyPeers( " $ Message $ ", " $ Other $ " )" );

	foreach VisibleActors( class'Predator', Friend, GroupRadius )
	{
		if( Friend != self )
		{
			Friend.PeerNotification( Self, Message, Other );
		}
	}
}

function PeerNotification( Pawn Instigator, name Message, Pawn Other )
	{
	 if( bDebugLog ) Log( self $ " PeerNotification( " $ Instigator $ ", " $ Message $ ", " $ Other $ " )" );

  MessageTime = Level.TimeSeconds;
		if( (message == 'Attack') && (!IsInState('Attacking') && !IsInState('Charging') && !IsInState('MeleeAttack') && !IsInState('TacticalMove')) )
		{
   if( bDebugLog ) Log( self $ " PeerNotification( " $ Instigator $ ", " $ Message $ ", " $ Other $ " )" );
			if( Enemy == none && Other != Enemy && SetEnemy( Other ) )
			{
   	LastSeenPos = Enemy.Location;
			}
			GotoState( 'Attacking' );
		}
		// 'Retreat'
	 else	if( (message == 'Retreat') && !IsInState('Hiding') && !IsInState('Retreating'))
		{
   if( bDebugLog ) Log( self $ " PeerNotification( " $ Instigator $ ", " $ Message $ ", " $ Other $ " )" );
			if( Other != Enemy && SetEnemy( Other ) )
			{
				 LastSeenPos = Enemy.Location;
			}
			GotoState( 'Hiding' );
		}
	}

function TakeDamage( int Damage, Pawn InstigatedBy, Vector HitLocation, Vector Momentum, name DamageType )
{
    	if( bDebugLog ) Log( self $ " ::TakeDamage( " $ Damage $ ", " $ InstigatedBy $ ", " $ HitLocation $ ", " $ Momentum $ ", " $ DamageType $ " ) state " $ GetStateName() );
	TakeDamageAndNotifyGroup( Damage, InstigatedBy, Hitlocation, Momentum, DamageType );
}

singular function TakeDamageAndNotifyGroup( int Damage, Pawn instigatedBy, Vector hitlocation, Vector momentum, name damageType )
{
	if( bDebugLog ) Log( self $ " ::TakeDamageAndNotifyGroup( " $ Damage $ ", " $ instigatedBy $ ", " $ HitLocation $ ", " $ Momentum $ ", " $ damageType $ " )" );
	Super.TakeDamage( Damage, instigatedBy, hitlocation, momentum, damageType );
 if ( instigatedBy == None )
				return;
	if ( Enemy != None )
		LastSeenPos = Enemy.Location;
   	if( bDebugLog ) Log( self $ " TakeDamage: GroupHealth " $ GetGroupHealth() $ " Health " $ Health );
	if( GetGroupHealth() <= RetreatThreshold * InstigatedBy.Health / 100.0 )
	{
		// Check if there are enough creatures left in the level to form an attack group.
		// if not, fight to the death!
		if( GetAllHealth() >= AttackThreshold * InstigatedBy.Health / 100.0 )
		{
			NotifyPeers( 'Retreat', Enemy );
			if( health <= 0 )
			{
				return;
			}
			else if( NextState == 'TakeHit' )
			{
				NextState = 'Hiding';
				NextLabel = 'Immediate';
				GotoState( 'TakeHit' );
			}
			else
			{
				GotoState( 'Hiding' );
			}
		}
		else
		{
			NotifyPeers( 'Attack', Enemy );
			if( health <= 0 )
			{
				return;
			}
			else if( NextState == 'TakeHit' )
			{
				NextState = 'Attacking';
				NextLabel = 'Begin';
				GotoState( 'TakeHit' );
			}
			else
			{
				GotoState( 'Attacking' );
			}
		}
	}
	else if( health <= 0 )
	{
		return;
	}
	else if( NextState == 'TakeHit' )
	{
		if( !IsInState( 'FallingState' ) )
		{
			NextState = GetStateName();
			if( NextState == 'Hiding' )
			{
				NextLabel = 'Immediate';
			}
			else
			{
				NextLabel = 'Begin';
			}
		}
		GotoState('TakeHit');
	}
}

function bool InMeleeRange( Pawn Other )
{
	local vector Dist2d;

	Dist2d = Location - Enemy.Location;
	Dist2d.Z = 0;
	return Abs( Location.Z - Other.Location.Z ) <= FMax( CollisionHeight, Other.CollisionHeight ) + 0.5 * FMin( CollisionHeight, Other.CollisionHeight ) &&
		VSize( Dist2d ) <= MeleeRange + CollisionRadius + Enemy.CollisionRadius;
}

// ====================
// Waiting
// ====================

state Waiting
{
	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation,
							Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			return;
		if ( Enemy != None )
			LastSeenPos = Enemy.Location;
		if( NextState == 'TakeHit' )
		{
			NextState = 'Hiding';
			NextLabel = 'Begin';
			GotoState('TakeHit');
		}
		else if ( Enemy != None )
		{
			if( GetGroupHealth() >= AttackThreshold * Enemy.Health / 100.0 ||
				GetAllHealth() < AttackThreshold * Enemy.Health / 100.0 )
			{
				NotifyPeers( 'Attack', Enemy );
				GotoState( 'Attacking' );
			}
			else
			{
				NotifyPeers( 'Retreat', Enemy );
				GotoState( 'Hiding' );
			}
		}
	}

	function Bump(actor Other)
	{
		//log(Other.class$" bumped "$class);
		if (Pawn(Other) != None)
		{
			SetEnemy(Pawn(Other));
		}
		if ( TimerRate <= 0 )
			setTimer(1.5, false);
		Disable('Bump');
	}

	function Timer()
	{
		Enable('Bump');
	}

	function PeerNotification( Pawn Instigator, name Message, Pawn Other )
	{
  if( bDebugLog ) Log( self $ " Waiting::PeerNotification( " $ Instigator $ ", " $ Message $ ", " $ Other $ " )" );
  MessageTime = Level.TimeSeconds;
		if (message == 'Attack')
		{
			if( Enemy == none && Other != Enemy && SetEnemy( Other ) )
			{
				LastSeenPos = Enemy.Location;
			}
			GotoState( 'Attacking' );
		}
   else	if(message == 'Retreat')
		{
   if( bDebugLog ) Log( self $ " PeerNotification( " $ Instigator $ ", " $ Message $ ", " $ Other $ " )" );
			if(Other != Enemy && SetEnemy( Other ) )  
			{
				LastSeenPos = Enemy.Location;
			}
			GotoState( 'Hiding' );
		}

		// 'Retreat'
	}

	function EnemyAcquired()
	{
		if( GetGroupHealth() >= AttackThreshold * Enemy.Health / 100.0 ||
			GetAllHealth() < AttackThreshold * Enemy.Health / 100.0 )
		{
			NotifyPeers( 'Attack', Enemy );
			GotoState('Attacking');
		}
		else
		{
			NotifyPeers( 'Retreat', Enemy );
			GotoState('Hiding');
		}
	}

	function AnimEnd()
	{
		PlayWaiting();
		bStasis = true;
	}

	function Landed(vector HitNormal)
	{
		SetPhysics(PHYS_None);
	}

	function BeginState()
	{
		Enemy = None;
		bStasis = false;
		Acceleration = vect(0,0,0);
		SetAlertness(0.0);
	}

TurnFromWall:
	if ( NearWall(2 * CollisionRadius + 50) )
	{
		PlayTurning();
		TurnTo(Focus);
	}
Begin:
	TweenToWaiting(0.4);
	bReadyToAttack = false;
	DesiredRotation = rot(0,0,0);
	DesiredRotation.Yaw = Rotation.Yaw;
	SetRotation(DesiredRotation);
	if (Physics != PHYS_Falling)
		SetPhysics(PHYS_None);
KeepWaiting:
	NextAnim = '';
}

// ====================
// Hiding
// ====================

state Hiding
{
 ignores  HearNoise, EnemyNotVisible;


	function SeePlayer(Actor SeenPlayer)
	{
		if ( (SeenPlayer == Enemy) || LineOfSightTo(Enemy) )
		{
			LastSeenTime = Level.TimeSeconds;
		}
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation,
							Vector momentum, name damageType)
	{
        		if( bDebugLog ) Log( self $ " Hiding::TakeDamage( " $ Damage $ ", " $ instigatedBy $ ", " $ HitLocation $ ", " $ Momentum $ ", " $ damageType $ " )" );
		TakeDamageAndNotifyGroup( Damage, InstigatedBy, HitLocation, Momentum, DamageType );
		}

	function PeerNotification( Pawn Instigator, name Message, Pawn Other )
	{
  if( bDebugLog ) Log( self $ " Hiding::PeerNotification( " $ Instigator $ ", " $ Message $ ", " $ Other $ " )" );
  MessageTime = Level.TimeSeconds;
		if( message == 'Attack' )
		{
			if( Enemy == none && Other != Enemy && SetEnemy( Other ) )
			{
				LastSeenPos = Enemy.Location;
			}
			GotoState( 'Attacking' );
		}
	}

	function Timer()
	{
		bReadyToAttack = True;
		Enable('Bump');
	}
	
	function SetFall()
	{
		NextState = 'Hiding';
		NextLabel = 'Landed';
		NextAnim = AnimSequence;
		GotoState('FallingState');
	}

	function HitWall(vector HitNormal, actor Wall)
	{
  bSpecialPausing = false;
		if (Physics == PHYS_Falling)
			return;
		if ( Wall.IsA('Mover') && Mover(Wall).HandleDoor(self) )
		{
			if ( SpecialPause > 0 )
				Acceleration = vect(0,0,0);
			GotoState('Hiding', 'SpecialNavig');
			return;
		}
		Focus = Destination;
		if ( PickWallAdjust() )
			{
   if ( Physics == PHYS_Falling )
			SetFall();
   else
   GotoState('Hiding', 'AdjustFromWall');
		 }
		else
		{
			Home = None;
			MoveTimer = -1.0;
		}
	}

	function PickDestination()
	{
		local NavigationPoint OldHome;
		local NavigationPoint NavPt;
  local NavigationPoint NP;
		//local HomeBase Base;
		local float Distance;
		local float NavPtDist;
		local int i, j, intz;
  local actor path;
  local float dist;
  local vector Dir;

 if (Level.TimeSeconds - LastSeenTime > 12 && Enemy != None)
			{
			Enemy = None;
   GotoState('Waiting');
			return;
			}
 
		if (Enemy == None) 
		{
			if (bDebugLog) log(self $" PickDestination: I have no enemy");
			GotoState('Attacking');
			return;
		}         

		if( Level.NavigationPointList == None )
		{
			// This level has no navigation points.  Attack (like a cornered animal).
	  if (bDebugLog) log(self $" this level has no navigation points");
   if ( Enemy != None )
			  {
     if ( Enemy.bIsPlayer)
					AttitudeToPlayer = ATTITUDE_Hate;
				else
					Hated = Enemy;
     }
   Aggressiveness += 0.3;
 		RetreatThreshold = 0.0;
			AttackThreshold = 0.0;
			GotoState( 'Attacking' );
   return;
		}   
		else
		{
			// Check current Home first

			if( Home != None ) {
				NavPtDist = VSize( Location - Home.Location );
				if( Enemy == None || !Enemy.LineOfSightTo( NavPt ) &&
					NavPtDist > CollisionRadius + Home.CollisionRadius &&
					VSize(Home.Location - Enemy.Location) > NavPtDist &&
					( ActorReachable( Home ) ) )
                {
     movetarget=home; 
			  destination=home.location;
     if (bDebugLog) log(self $" Check current Home first returning");
					return;
				} 
			}		
			Distance = 1048576.0;
//			DestListSize = 0;
			if (bDebugLog) log( Self $ " PickDestination: at " $ Location );
			for( NavPt = Level.NavigationPointList; NavPt != None; NavPt = NavPt.NextNavigationPoint )
			{
				NavPtDist = VSize( Location - NavPt.Location );
				if (bDebugLog) log( self $ " PickDestination: considering " $ NavPt $ "(" $ NavPt.Tag $ ") at " $ NavPt.Location $ " distance " $ NavPtDist $ " reachable " $ ActorReachable( NavPt ) $ " enemy " $ Enemy $ " LOS " $ Enemy.LineOfSightTo( NavPt ) );
				if( ( Enemy == None || !Enemy.LineOfSightTo( NavPt ) ) &&
					NavPtDist > CollisionRadius + NavPt.CollisionRadius )
				{
					if( NavPtDist < Distance && VSize(NavPt.Location - Enemy.Location) > NavPtDist )
					{
						if (bDebugLog) log( self $ " PickDestination: selected " $ NavPt $ "(" $ NavPt.Tag $ ") at " $ NavPt.Location $ " reachable " $ ActorReachable( NavPt ) );
      if (Home != none)
      home=none;
 					Home = NavPt;
						Distance = NavPtDist;
				}  
				}
    }  

    if( bDebugLog ) log( self $ " PickDestination: found " $ Home );
			 if ( Home != None )
					{
      if( actorReachable(home) )
								{
         movetarget=home; 
			      destination=home.location;
									return;    
         }
							else
									{
         Path = FindPathToward(home);
		      	if( path != none )
										{
          movetarget=path;
			       destination=path.location;
										return;
										}
									 }
						}
    }
    if( bDebugLog )log("I have no home going to Attacking from pickdest");
    RetreatThreshold = 0.0;
			 AttackThreshold = 0.0;
				GotoState( 'Attacking' );
	}

	function Bump(actor Other)
	{
		local vector VelDir, OtherDir;
		local float speed;

		//log(Other.class$" bumped "$class);
		if (Pawn(Other) != None)
		{
			return;
		} 
		if (Other.IsA('Decoration') && Decoration(Other) != None )
		{
   if ((HomeBase(Home) != None) && VSize(Home.Location - Location) < 2.2 * ( CollisionRadius + Decoration(Other).CollisionRadius) )
			    ReachedHome();
		}
		if ( TimerRate <= 0 )
			setTimer(1.0, false);
		
		speed = VSize(Velocity);
		if ( speed > 1 )
		{
			VelDir = Velocity/speed;
			VelDir.Z = 0;
			OtherDir = Other.Location - Location;
			OtherDir.Z = 0;
			OtherDir = Normal(OtherDir);
			if ( (VelDir Dot OtherDir) > 0.9 )
			{
				Velocity.X = VelDir.Y;
				Velocity.Y = -1 * VelDir.X;
				Velocity *= FMax(speed, 200);
			}
		} 
		Disable('Bump');
	}

	function ReachedHome()
	{
		local Rotator dir;
		if (LineOfSightTo(Enemy))
		{
   if (bDebugLog) log(self $"ReachedHome and LineOfSightTo Enemy ");
			PickDestination();
			GotoState('Hiding', 'RunAway');
		}
		else
		{
   if (bDebugLog) log(self $"ReachedHome TurnAtHome");
			GotoState('Hiding', 'TurnAtHome');
		}
 }
	function PickNextSpot()
	{
		local Actor path;
		local vector dist2d;
		local float zdiff;

		if ( Home == None )
		{
			if (bDebugLog) log(self $"PickNextSpot No Home picking new one");
			PickDestination();
			if ( Home == None )
				return;
		} 
		//log("find retreat spot");
		dist2d = Home.Location - Location;
		zdiff = dist2d.Z;
		dist2d.Z = 0.0;	  
		if ((VSize(dist2d) < 2.2 * CollisionRadius) && (Abs(zdiff) < CollisionHeight))
			ReachedHome();
		else
		{  
   PickDestination();
		}      
	}

	function AnimEnd()
	{
		if ( bSpecialPausing )
			PlayPatrolStop();
		else
			PlayRunning();
	}

	function BeginState()
	{
		bCanFire = false;
		bSpecialPausing = false;
		SpecialGoal = None;
		SpecialPause = 0.0;
	}

	function TurnAround()
	{
		local Vector Loc;
		local Rotator Rot;
		Loc = Location - Vector( Rotation );
		Rot = Rotator( Loc - Location );
        if( bDebugLog ) log( self $ " TurnAround from " $ Rotation $ " to " $ Rot );
		DesiredRotation = Rot;
		SetRotation( DesiredRotation );
	}


Begin:
	//log(self $" hiding");
 if ( Enemy == none )
   GotoState('Attacking');
 SetMovementPhysics();
 Acceleration = vect(0,0,0);
	if ( bReadyToAttack && (FRand() < 0.6) )
	{
		SetTimer(TimeBetweenAttacks, false);
		bReadyToAttack = false;
	}
 PlayFearSound();
	if( FRand() < 0.3 )
	{
		Disable( 'AnimEnd' );
        	if( bDebugLog ) log( self $ " TweenAnim('Threat', 0,1);" );
		TweenAnim( 'Threat', 0.1 );
		FinishAnim();
        	if( bDebugLog ) log( self $ " PlayAnim('Threat');" );
		PlayAnim( 'Threat' );
		TurnTo( Enemy.Location - Location );
        	if( bDebugLog ) log( self $ " FinishAnim();" );
		FinishAnim();
		NextAnim = '';
		Enable( 'AnimEnd' );
	}
StartRun:
 SetMovementPhysics();
	TweenToRunning(0.1);
	WaitForLanding();
	PickDestination();

Landed:
	TweenToRunning(0.1);
	
RunAway:
 if( bDebugLog ) log( Self $ " Hiding:RunAway" );
	if( Enemy != None &&
		( GetGroupHealth() >= AttackThreshold * Enemy.Health / 100.0 ||
		  GetAllHealth() < AttackThreshold * Enemy.Health / 100.0 ) )
	{
		NotifyPeers( 'Attack', Enemy );
		GotoState('Attacking');
	}

SpecialNavig:
	if (SpecialPause > 0.0)
	{
		bSpecialPausing = true;
		Acceleration = vect(0,0,0);
		TweenToPatrolStop(0.25);
		Sleep(SpecialPause);
		SpecialPause = 0.0;
		bSpecialPausing = false;
		TweenToRunning(0.1);
	}
Moving:
	if ( MoveTarget == None )
	{
		Sleep(0.0);
		Goto('StartRun');
	}
		MoveToward(MoveTarget);
  PickNextSpot();
	Goto('RunAway');

TakeHit:
	TweenToRunning(0.12);
	Goto('Moving');

AdjustFromWall:
	StrafeTo(Destination, Focus); 
	Destination = Focus; 
	MoveTo(Destination);
	Goto('Moving');

TurnAtHome:
	Acceleration = vect(0,0,0);
	if( Homebase(Home) != None ) {
		TurnTo(Homebase(Home).lookdir);
	} else {
		TurnAround();
	}
	GotoState('Waiting');

Immediate:
	SetMovementPhysics();
	PlayFearSound();
	Goto( 'StartRun' );

}

// ====================
// Retreating
// ====================

state Retreating
{
ignores SeePlayer, EnemyNotVisible, HearNoise;
ignores TakeDamage, Timer, SetFall, HitWall;
ignores Bump, AnimEnd, BeginState;

Begin:
	GotoState( 'Hiding' );
}

// ====================
// Attacking
// ====================

state Attacking
{
ignores SeePlayer, HearNoise, Bump, HitWall;

	function ChooseAttackMode()
	{
		local eAttitude AttitudeToEnemy;
		local float Aggression;
		local pawn changeEn;

		if ((Enemy == None) || (Enemy.Health <= 0) || (Enemy.bDeleteme))
		{
			if (Orders == 'Attacking')
				Orders = '';
			WhatToDoNext('','');
			return;
		}

		if ( (AlarmTag != '') && Enemy.bIsPlayer )
		{
			if (AttitudeToPlayer > ATTITUDE_Ignore)
			{
				GotoState('AlarmPaused', 'WaitForPlayer');
				return;
			}
			else if ( (AttitudeToPlayer != ATTITUDE_Fear) || bInitialFear )
			{
				GotoState('TriggerAlarm');
				return;
			}
		}

		AttitudeToEnemy = AttitudeTo(Enemy);

		if (AttitudeToEnemy == ATTITUDE_Fear)
		{
			GotoState('Retreating');
			return;
		}

		else if (AttitudeToEnemy == ATTITUDE_Threaten)
		{
			GotoState('Threatening');
			return;
		}

		else if (AttitudeToEnemy == ATTITUDE_Friendly)
		{
			if (Enemy.bIsPlayer)
				GotoState('Greeting');
			else
				WhatToDoNext('','');
			return;
		}

		else if (!LineOfSightTo(Enemy))
	     	{
			if ( (OldEnemy != none  )
				&& (AttitudeTo(OldEnemy) == ATTITUDE_Hate) && LineOfSightTo(OldEnemy) && !OldEnemy.bDeleteme)
			{
				changeEn = enemy;
				enemy = oldenemy;
				oldenemy = changeEn;
			}
			else
			{
				if ( (Orders == 'Guarding') && !LineOfSightTo(OrderObject) )
					GotoState('Guarding');
				else if ( !bHasRangedAttack || VSize(Enemy.Location - Location)
							> 600 + (FRand() * RelativeStrength(Enemy) - CombatStyle) * 600 )
					GotoState('Hunting');
				else if ( bIsBoss || (Intelligence > BRAINS_None) )
				{
					HuntStartTime = Level.TimeSeconds;
					NumHuntPaths = 0;
					GotoState('StakeOut');
				}
				else
					WhatToDoNext('Waiting', 'TurnFromWall');
				return;
			}
		}

		else if ( (TeamLeader != None) && TeamLeader.ChooseTeamAttackFor(self) )
			return;

		if (bReadyToAttack)
		{
			////log("Attack!");
			Target = Enemy;
			If (VSize(Enemy.Location - Location) <= (MeleeRange + Enemy.CollisionRadius + CollisionRadius))
			{
				GotoState('MeleeAttack');
				return;
			}


		}

		//decide whether to charge or make a tactical move
		if ( !bHasRangedAttack )
			GotoState('Charging');
		else
		    bHasRangedAttack = false;
		    GotoState('TacticalMove');
		//log("Next state is "$state);
	}

	//EnemyNotVisible implemented so engine will update LastSeenPos
	function EnemyNotVisible()
	{
		////log("enemy not visible");
	}

	function Timer()
	{
		bReadyToAttack = True;
	}

	function BeginState()
	{
		if ( TimerRate <= 0.0 )
			SetTimer(TimeBetweenAttacks  * (1.0 + FRand()),false);
		if (Physics == PHYS_None)
			SetMovementPhysics();
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, Vector momentum, name damageType )
	{
        		if( bDebugLog ) Log( self $ " Attacking::TakeDamage( " $ Damage $ ", " $ instigatedBy $ ", " $ HitLocation $ ", " $ Momentum $ ", " $ damageType $ " )" );
		TakeDamageAndNotifyGroup( Damage, InstigatedBy, HitLocation, Momentum, DamageType );
	}
	function PeerNotification( Pawn Instigator, name Message, Pawn Other )
	{
  if( bDebugLog ) Log( self $ " Attacking::PeerNotification( " $ Instigator $ ", " $ Message $ ", " $ Other $ ")" );
		//'Attack'
  MessageTime = Level.TimeSeconds;
		if( message == 'Retreat' )
		{
			if( Other != Enemy && SetEnemy( Other ) )
			{
				LastSeenPos = Enemy.Location;
			}
			GotoState( 'Hiding' );
		}
	}

Begin:
	//log(class$" choose Attack");
	ChooseAttackMode();
}


// ====================
// MeleeAttack
// ====================

state MeleeAttack
{
 ignores SeePlayer, HearNoise, Bump;

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, Vector momentum, name damageType )
	{
        		if( bDebugLog ) Log( self $ " MeleeAttack::TakeDamage( " $ Damage $ ", " $ instigatedBy $ ", " $ HitLocation $ ", " $ Momentum $ ", " $ damageType $ " )" );
		TakeDamageAndNotifyGroup( Damage, InstigatedBy, HitLocation, Momentum, DamageType );
	}

	function PeerNotification( Pawn Instigator, name Message, Pawn Other )
	{
  if( bDebugLog ) Log( self $ " MeleeAttack::PeerNotification( " $ Instigator $ ", " $ Message $ ", " $ Other $ ")" );
  MessageTime = Level.TimeSeconds;
		if( message == 'Retreat' )
		{
			if( Other != Enemy && SetEnemy( Other ) )
			{
				LastSeenPos = Enemy.Location;
			}
			GotoState( 'Hiding' );
		}
	}

 function KeepAttacking()
	{
		if ( (Enemy == None) || enemy.bDeleteme || (VSize(Enemy.Location - Location) > (MeleeRange + Enemy.CollisionRadius + CollisionRadius)) )
			GotoState('Attacking');
	}

	function BeginState()
	{
		if  (Enemy != none && Enemy.Health > 0 && !Enemy.bDeleteme)
        Target = Enemy;
		    Disable('AnimEnd');
		    bReadyToAttack = false;
	}

Begin:
	if ( Enemy == None  || Enemy.Health <= 0 || Enemy.bDeleteme)
			GotoState( 'Attacking' );
		DesiredRotation = Rotator( Enemy.Location - Location );
	if( skill < 3 )
			TweenToFighter( 0.15 );
	else
	    	TweenToFighter( 0.11 );

FaceTarget:
//	Acceleration = vect(0,0,0); //stop
	if( NeedToTurn( Enemy.Location ) )
	{
		PlayTurning();
		TurnToward( Enemy );
		TweenToFighter( 0.10 );
	}
	FinishAnim();
	OldAnimRate = 0;	// force no tween

	if( !InMeleeRange( Enemy ) )
	{
  Playrunning();
		GotoState( 'Charging' );
	}
ReadyToAttack:
	DesiredRotation = Rotator( Enemy.Location - Location );
 if (xxMovingMelee() )
 PlayMovingMelee();
	else
	PlayMeleeAttack();
	Enable( 'AnimEnd' );
Attacking:
 if ( Enemy == None  || Enemy.Health <= 0 || Enemy.bDeleteme)
  GotoState('Attacking');
	TurnToward( Enemy );
	Goto( 'Attacking' );
DoneAttacking:
	Disable( 'AnimEnd' );
	KeepAttacking();
	if( FRand() < 0.3 - 0.1 * skill )
	{
		Acceleration = vect(0,0,0); //stop
		DesiredRotation = Rotator( Enemy.Location - Location );
		PlayChallenge();
		FinishAnim();
		TweenToFighter( 0.1 );
	}
	Goto('FaceTarget');
}  

state Hunting
{
ignores EnemyNotVisible;

	function HitWall(vector HitNormal, actor Wall)
	{
		if (Physics == PHYS_Falling)
			return;
		if ( Wall.IsA('Mover') && Mover(Wall).HandleDoor(self) )
		{
			if ( SpecialPause > 0 )
				Acceleration = vect(0,0,0);
			GotoState('Hunting', 'SpecialNavig');
			return;
		}
		Focus = Destination;
  if (PickWallAdjust())
   {
   if ( Physics == PHYS_Falling )
				SetFall();
			else
			GotoState('Hunting', 'AdjustFromWall');
			}
		else
			MoveTimer = -1.0;
	}

	function BeginState()
	{
		bCanSwim = true;
		Super.BeginState();
	}

	function EndState()
	{
		if ( !Region.Zone.bWaterZone )
			bCanSwim = false;
		Super.EndState();
	}
}

//=========================================================================================

function TryToDuck(vector duckDir, bool bReversed)
{
	local vector HitLocation, HitNormal, Extent;
	local bool duckLeft, bSuccess;
	local actor HitActor;
	local float decision;

	//log("duck");

	duckDir.Z = 0;
	duckLeft = !bReversed;

	Extent.X = CollisionRadius;
	Extent.Y = CollisionRadius;
	Extent.Z = CollisionHeight;
	HitActor = Trace(HitLocation, HitNormal, Location + 200 * duckDir, Location, false, Extent);
	bSuccess = ( (HitActor == None) || (VSize(HitLocation - Location) > 150) );
	if ( !bSuccess )
	{
		duckLeft = !duckLeft;
		duckDir *= -1;
		HitActor = Trace(HitLocation, HitNormal, Location + 200 * duckDir, Location, false, Extent);
		bSuccess = ( (HitActor == None) || (VSize(HitLocation - Location) > 150) );
	}
	if ( !bSuccess )
		return;

	if ( HitActor == None )
		HitLocation = Location + 200 * duckDir;
	HitActor = Trace(HitLocation, HitNormal, HitLocation - MaxStepHeight * vect(0,0,1), HitLocation, false, Extent);
	if (HitActor == None)
		return;

	//log("good duck");

	SetFall();
	PlayAnim('Jump');
	Velocity = duckDir * GroundSpeed;
	Velocity.Z = 200;
	SetPhysics(PHYS_Falling);
	GotoState('FallingState','Ducking');
}

function PlayPatrolStop()
{
	local float decision;
	if (Region.Zone.bWaterZone)
	{
		PlaySwimming();
		return;
	}
		SetAlertness(0.2);
		LoopAnim('idle', 0.3 + 0.6 * FRand());
}

function PlayChallenge()
{
	if (Region.Zone.bWaterZone)
	{
		PlaySwimming();
		return;
	}
	PlayThreateningSound();
	PlayAnim( 'Threat', 0.8 + 0.5 * FRand(), 0.1 );
}

function PlayRunning()
{
	local float strafeMag;
	local vector Focus2D, Loc2D, Dest2D;
	local vector lookDir, moveDir, Y;

	DesiredSpeed = MaxDesiredSpeed;
	if (Region.Zone.bWaterZone)
	{
		PlaySwimming();
		return;
	}

	if (Focus == Destination)
	{
		LoopAnim('Run', -2.0/GroundSpeed,, 0.5);
		return;
	}
	Focus2D = Focus;
	Focus2D.Z = 0;
	Loc2D = Location;
	Loc2D.Z = 0;
	Dest2D = Destination;
	Dest2D.Z = 0;
	lookDir = Normal(Focus2D - Loc2D);
	moveDir = Normal(Dest2D - Loc2D);
	strafeMag = lookDir dot moveDir;
	if (strafeMag > 0.8)
		LoopAnim('Run', -2.0/GroundSpeed,, 0.5);
	else if (strafeMag < -0.8)
		LoopAnim('Run', -2.0/GroundSpeed,, 0.5);
	else
	{
		Y = (lookDir Cross vect(0,0,1));
		if ((Y Dot (Dest2D - Loc2D)) > 0)
		{
		LoopAnim( 'Run', -5.0/GroundSpeed,0.1, 1.0 );
		}
	}
}
								
function PlayThreatening()
{
	local float decision, animspeed;

	if (Region.Zone.bWaterZone)
	{
		PlaySwimming();
		return;
	}

	decision = FRand();
	animspeed = 0.4 + 0.6 * FRand();

	if ( decision < 0.7 )
		PlayAnim('Idle', animspeed, 0.3);
	else if ( decision < 0.9 )
	{
		PlayThreateningSound();
		PlayAnim('Threat', animspeed, 0.3);
	}
	else
	{
	  PlayAnim('Threat', animspeed, 0.3);
	}
}

function PlayVictoryDance()
{
	PlayAnim('Threat', 0.6, 0.1);
}

defaultproperties
{
				BiteDamage=101
				AttackThreshold=300.000000
				RetreatThreshold=150.000000
				GroupRadius=712.000000
				HitSound3=Sound'KLJ.Predator.hurt3'
				bite=Sound'KLJ.Predator.bite'
				Footstep=Sound'KLJ.Predator.step1'
				Footstep2=Sound'KLJ.Predator.step2'
				fear2=Sound'KLJ.Predator.fear2'
				fear3=Sound'KLJ.Predator.fear3'
				CarcassType=Class'KLJ.PredatorCarcass'
				RefireRate=0.500000
				bIsWuss=True
				bLeadTarget=False
				bWarnTarget=False
				Acquire=Sound'KLJ.Predator.hate'
				Fear=Sound'KLJ.Predator.fear1'
				Roam=Sound'KLJ.Predator.Idle'
				Threaten=Sound'KLJ.Predator.hate'
				MeleeRange=60.000000
				GroundSpeed=525.000000
				AccelRate=1200.000000
				JumpZ=225.000000
				PeripheralVision=-1.000000
				Health=1600
				UnderWaterTime=-1.000000
				AttitudeToPlayer=ATTITUDE_Ignore
				HitSound1=Sound'KLJ.Predator.hurt1'
				HitSound2=Sound'KLJ.Predator.hurt2'
				Die=Sound'KLJ.Predator.Die'
				CombatStyle=1.000000
				DrawType=DT_Mesh
				Mesh=LodMesh'KLJ.Predator'
				AmbientSound=Sound'KLJ.Predator.Idle'
				TransientSoundVolume=3.000000
				CollisionRadius=16.000000
				CollisionHeight=32.000000
				Mass=50.000000
				Buoyancy=50.000000
				RotationRate=(Pitch=3072,Yaw=120000,Roll=2048)
}
